/*
 * File:   auxiliary.hh
 * Author: mikolas
 *
 * Created on October 12, 2011
 */
#ifndef AUXILIARY_HH
#define	AUXILIARY_HH
#include <vector>
#include <unordered_map>
#include <unordered_set>
#include <iostream>
#include <sys/time.h>
#include <sys/resource.h>
#include <string.h>
#include <assert.h>
#define __PL (std::cerr << __FILE__ << ":" << __LINE__ << std::endl).flush();
#define FOR_EACH(index,iterated)\
  for (auto index = (iterated).begin(); index != (iterated).end();++index)
#ifdef USE_GL
#define SATSPC Glucose
#else
#define SATSPC Minisat 
#endif

static inline double read_cpu_time() {
  struct rusage ru; getrusage(RUSAGE_SELF, &ru);
  return (double)ru.ru_utime.tv_sec + (double)ru.ru_utime.tv_usec / 1000000;
}

struct cstrHash {
  inline size_t operator() (const char* s) const {
    size_t hash = 5381;
    char c;
    while (c = *s++)
      hash = ((hash << 5) + hash) + c; /* hash * 33 + c */
    return hash;
  }
};

struct cstrEq {
  inline size_t operator() (const char* s1,const char* s2) const {
    return strcmp(s1,s2)==0; };
};

namespace areqs2 {

template<class K,class V>
inline bool contains(const std::unordered_map<K,V>& es, const K& e) {
  return es.find(e) != es.end();
}

template<class K>
inline bool contains(const std::unordered_set<K>& es, const K& e) {
  return es.find(e) != es.end();
}

};
#endif	/* AUXILIARY_HH */

