/*
 * File:  qtypes.hh
 * Author:  mikolas
 * Created on:  Fri, Aug 01, 2014 4:42:21 PM
 * Copyright (C) 2014, Mikolas Janota
 */
#ifndef QTYPES_HH_15436
#define QTYPES_HH_15436
#include <vector>
#include <ostream>
namespace areqs2 {
  typedef std::pair<QuantifierType,VarVector> Quantification;
  typedef std::vector<Quantification> Prefix;
  typedef struct {
    Prefix pref;
    ID     output;
  } QFla;

  inline std::ostream& print (
       const unordered_map<int,const char*>& var2name,
       std::ostream& outs,
       const Prefix& pref) {
    outs<<"["<<std::endl;
    FOR_EACH(i,pref) {
      Quantification q=*i;
      outs<<(q.first==UNIVERSAL?"A":"E");
      FOR_EACH(vi,q.second) outs<<" "<<var2name.find(*vi)->second;
      outs<<std::endl;
    }
    return outs<<"]";
  }
};

namespace std {
  inline std::ostream& operator << (std::ostream& outs, const areqs2::Prefix& pref) {
    outs<<"["<<std::endl;
    FOR_EACH(i,pref) {
      areqs2::Quantification q=*i;
      outs<<(q.first==areqs2::UNIVERSAL?"A":"E");
      FOR_EACH(vi,q.second) outs<<" "<<*vi;
      outs<<endl;
    }
    return outs<<"]";
  }
};
#endif /* QTYPES_HH_15436 */
